require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_GENERIC_PGTABLE_H)) {
    eval 'sub _ASM_GENERIC_PGTABLE_H () {1;}' unless defined(&_ASM_GENERIC_PGTABLE_H);
    unless(defined(&__HAVE_ARCH_PTEP_ESTABLISH)) {
	unless(defined(&__HAVE_ARCH_SET_PTE_ATOMIC)) {
	    eval 'sub ptep_establish {
	        my($__vma, $__address, $__ptep, $__entry) = @_;
    		eval q( &do {  &set_pte_at(($__vma)-> &vm_mm, ($__address), $__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	    }' unless defined(&ptep_establish);
	} else {
	    eval 'sub ptep_establish {
	        my($__vma, $__address, $__ptep, $__entry) = @_;
    		eval q( &do {  &set_pte_atomic($__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	    }' unless defined(&ptep_establish);
	}
    }
    unless(defined(&__HAVE_ARCH_PTEP_SET_ACCESS_FLAGS)) {
	eval 'sub ptep_set_access_flags {
	    my($__vma, $__address, $__ptep, $__entry, $__dirty) = @_;
    	    eval q( &do {  &set_pte_at(($__vma)-> &vm_mm, ($__address), $__ptep, $__entry);  &flush_tlb_page($__vma, $__address); }  &while (0));
	}' unless defined(&ptep_set_access_flags);
    }
    unless(defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG)) {
	eval 'sub ptep_test_and_clear_young {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte = *($__ptep); \'int\'  &r = 1;  &if (! &pte_young( &__pte))  &r = 0;  &else  &set_pte_at(($__vma)-> &vm_mm, ($__address), ($__ptep),  &pte_mkold( &__pte));  &r; }));
	}' unless defined(&ptep_test_and_clear_young);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_YOUNG_FLUSH)) {
	eval 'sub ptep_clear_flush_young {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({ \'int\'  &__young;  &__young =  &ptep_test_and_clear_young($__vma, $__address, $__ptep);  &if ( &__young)  &flush_tlb_page($__vma, $__address);  &__young; }));
	}' unless defined(&ptep_clear_flush_young);
    }
    unless(defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY)) {
	eval 'sub ptep_test_and_clear_dirty {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte = *$__ptep; \'int\'  &r = 1;  &if (! &pte_dirty( &__pte))  &r = 0;  &else  &set_pte_at(($__vma)-> &vm_mm, ($__address), ($__ptep),  &pte_mkclean( &__pte));  &r; }));
	}' unless defined(&ptep_test_and_clear_dirty);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_DIRTY_FLUSH)) {
	eval 'sub ptep_clear_flush_dirty {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({ \'int\'  &__dirty;  &__dirty =  &ptep_test_and_clear_dirty($__vma, $__address, $__ptep);  &if ( &__dirty)  &flush_tlb_page($__vma, $__address);  &__dirty; }));
	}' unless defined(&ptep_clear_flush_dirty);
    }
    unless(defined(&__HAVE_ARCH_PTEP_GET_AND_CLEAR)) {
	eval 'sub ptep_get_and_clear {
	    my($__mm, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte = *($__ptep);  &pte_clear(($__mm), ($__address), ($__ptep));  &__pte; }));
	}' unless defined(&ptep_get_and_clear);
    }
    unless(defined(&__HAVE_ARCH_PTEP_CLEAR_FLUSH)) {
	eval 'sub ptep_clear_flush {
	    my($__vma, $__address, $__ptep) = @_;
    	    eval q(({  &pte_t  &__pte;  &__pte =  &ptep_get_and_clear(($__vma)-> &vm_mm, $__address, $__ptep);  &flush_tlb_page($__vma, $__address);  &__pte; }));
	}' unless defined(&ptep_clear_flush);
    }
    unless(defined(&__HAVE_ARCH_PTEP_SET_WRPROTECT)) {
	eval 'sub ptep_set_wrprotect {
	    my($mm,$address,$ptep) = @_;
    	    eval q({  &pte_t  &old_pte = *$ptep;  &set_pte_at($mm, $address, $ptep,  &pte_wrprotect( &old_pte)); });
	}' unless defined(&ptep_set_wrprotect);
    }
    unless(defined(&__HAVE_ARCH_PTE_SAME)) {
	eval 'sub pte_same {
	    my($A,$B) = @_;
    	    eval q(( &pte_val($A) ==  &pte_val($B)));
	}' unless defined(&pte_same);
    }
    unless(defined(&__HAVE_ARCH_PAGE_TEST_AND_CLEAR_DIRTY)) {
	eval 'sub page_test_and_clear_dirty {
	    my($page) = @_;
    	    eval q((0));
	}' unless defined(&page_test_and_clear_dirty);
    }
    unless(defined(&__HAVE_ARCH_PAGE_TEST_AND_CLEAR_YOUNG)) {
	eval 'sub page_test_and_clear_young {
	    my($page) = @_;
    	    eval q((0));
	}' unless defined(&page_test_and_clear_young);
    }
    unless(defined(&__HAVE_ARCH_PGD_OFFSET_GATE)) {
	eval 'sub pgd_offset_gate {
	    my($mm, $addr) = @_;
    	    eval q( &pgd_offset($mm, $addr));
	}' unless defined(&pgd_offset_gate);
    }
    unless(defined(&__HAVE_ARCH_LAZY_MMU_PROT_UPDATE)) {
	eval 'sub lazy_mmu_prot_update {
	    my($pte) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&lazy_mmu_prot_update);
    }
    eval 'sub pgd_addr_end {
        my($addr, $end) = @_;
	    eval q(({ \'unsigned long __boundary\' = (($addr) +  &PGDIR_SIZE) &  &PGDIR_MASK; ( &__boundary - 1< ($end) - 1)?  &__boundary: ($end); }));
    }' unless defined(&pgd_addr_end);
    unless(defined(&pud_addr_end)) {
	eval 'sub pud_addr_end {
	    my($addr, $end) = @_;
    	    eval q(({ \'unsigned long __boundary\' = (($addr) +  &PUD_SIZE) &  &PUD_MASK; ( &__boundary - 1< ($end) - 1)?  &__boundary: ($end); }));
	}' unless defined(&pud_addr_end);
    }
    unless(defined(&pmd_addr_end)) {
	eval 'sub pmd_addr_end {
	    my($addr, $end) = @_;
    	    eval q(({ \'unsigned long __boundary\' = (($addr) +  &PMD_SIZE) &  &PMD_MASK; ( &__boundary - 1< ($end) - 1)?  &__boundary: ($end); }));
	}' unless defined(&pmd_addr_end);
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub pgd_none_or_clear_bad {
	    my($pgd) = @_;
    	    eval q({  &if ( &pgd_none(*$pgd)) 1;  &if ( &unlikely( &pgd_bad(*$pgd))) {  &pgd_clear_bad($pgd); 1; } 0; });
	}' unless defined(&pgd_none_or_clear_bad);
	eval 'sub pud_none_or_clear_bad {
	    my($pud) = @_;
    	    eval q({  &if ( &pud_none(*$pud)) 1;  &if ( &unlikely( &pud_bad(*$pud))) {  &pud_clear_bad($pud); 1; } 0; });
	}' unless defined(&pud_none_or_clear_bad);
	eval 'sub pmd_none_or_clear_bad {
	    my($pmd) = @_;
    	    eval q({  &if ( &pmd_none(*$pmd)) 1;  &if ( &unlikely( &pmd_bad(*$pmd))) {  &pmd_clear_bad($pmd); 1; } 0; });
	}' unless defined(&pmd_none_or_clear_bad);
    }
}
1;
