require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_BITOPS_H)) {
    eval 'sub _X86_64_BITOPS_H () {1;}' unless defined(&_X86_64_BITOPS_H);
    require 'linux/config.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub LOCK_PREFIX () {"lock ; ";}' unless defined(&LOCK_PREFIX);
    } else {
	eval 'sub LOCK_PREFIX () {"";}' unless defined(&LOCK_PREFIX);
    }
    eval 'sub ADDR () {(*( &volatile \'long\' *)  &addr);}' unless defined(&ADDR);
    eval 'sub __clear_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__clear_bit);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &barrier());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &barrier());
    }' unless defined(&smp_mb__after_clear_bit);
    if(0) {
    }
    eval 'sub constant_test_bit {
        my($nr,$addr) = @_;
	    eval q({ ((1 << ($nr & 31)) & ((( &const  &volatile \'unsigned int\' *) $addr)[$nr >> 5])) != 0; });
    }' unless defined(&constant_test_bit);
    eval 'sub variable_test_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&variable_test_bit);
    eval 'sub test_bit {
        my($nr,$addr) = @_;
	    eval q(( &__builtin_constant_p($nr) ?  &constant_test_bit(($nr),($addr)) :  &variable_test_bit(($nr),($addr))));
    }' unless defined(&test_bit);
    undef(&ADDR) if defined(&ADDR);
    eval 'sub find_first_bit {
        my($addr,$size) = @_;
	    eval q((( &__builtin_constant_p($size)  && ($size) <=  &BITS_PER_LONG ? ( &__scanbit(*$addr,($size))) :  &find_first_bit($addr,$size))));
    }' unless defined(&find_first_bit);
    eval 'sub find_next_bit {
        my($addr,$size,$off) = @_;
	    eval q((( &__builtin_constant_p($size)  && ($size) <=  &BITS_PER_LONG ? (($off) + ( &__scanbit((*$addr) >> ($off),($size)-($off)))) :  &find_next_bit($addr,$size,$off))));
    }' unless defined(&find_next_bit);
    eval 'sub find_first_zero_bit {
        my($addr,$size) = @_;
	    eval q((( &__builtin_constant_p($size)  && ($size) <=  &BITS_PER_LONG ? ( &__scanbit(~*$addr,($size))) :  &find_first_zero_bit($addr,$size))));
    }' unless defined(&find_first_zero_bit);
    eval 'sub find_next_zero_bit {
        my($addr,$size,$off) = @_;
	    eval q((( &__builtin_constant_p($size)  && ($size) <=  &BITS_PER_LONG ? (($off)+( &__scanbit(~(((*$addr)) >> ($off)),($size)-($off)))) :  &find_next_zero_bit($addr,$size,$off))));
    }' unless defined(&find_next_zero_bit);
    eval 'sub set_bit_string {
        my($bitmap,$i,$len) = @_;
	    eval q({ my $end = $i + $len;  &while ($i <  $end) {  &__set_bit($i, $bitmap); $i++; } } );
    }' unless defined(&set_bit_string);
    eval 'sub __clear_bit_string {
        my($bitmap,$i,$len) = @_;
	    eval q({ my $end = $i + $len;  &while ($i <  $end) {  &__clear_bit($i, $bitmap); $i++; } } );
    }' unless defined(&__clear_bit_string);
    if(defined(&__KERNEL__)) {
	eval 'sub sched_find_first_bit {
	    my($b) = @_;
    	    eval q({  &if ($b->[0])  &__ffs($b->[0]);  &if ($b->[1])  &__ffs($b->[1]) + 64;  &if ($b->[2])  &__ffs($b->[2]) + 128; });
	}' unless defined(&sched_find_first_bit);
	eval 'sub hweight64 {
	    my($x) = @_;
    	    eval q( &generic_hweight64($x));
	}' unless defined(&hweight64);
	eval 'sub hweight32 {
	    my($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    my($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    my($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
    }
    if(defined(&__KERNEL__)) {
	eval 'sub ext2_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_set_bit(($nr),$addr));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_set_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_set_bit(($nr),$addr));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit(($nr),$addr));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_clear_bit(($nr),$addr));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit {
	    my($nr, $addr) = @_;
    	    eval q( &test_bit(($nr),$addr));
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_first_zero_bit($addr, $size));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    my($addr, $size, $off) = @_;
    	    eval q( &find_next_zero_bit($addr, $size, $off));
	}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_set_bit($nr,( &void*)$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__set_bit($nr,( &void*)$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_clear_bit($nr,( &void*)$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_bit($nr,( &void*)$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &find_first_zero_bit(( &void*)$addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
	eval 'sub fls {
	    my($x) = @_;
    	    eval q( &generic_fls($x));
	}' unless defined(&fls);
	eval 'sub ARCH_HAS_ATOMIC_UNSIGNED () {1;}' unless defined(&ARCH_HAS_ATOMIC_UNSIGNED);
    }
}
1;
