require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SMP_H)) {
    eval 'sub __ASM_SMP_H () {1;}' unless defined(&__ASM_SMP_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/config.ph';
	require 'linux/threads.ph';
	require 'linux/cpumask.ph';
	require 'linux/bitops.ph';
    }
    if(defined(&CONFIG_X86_LOCAL_APIC)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/fixmap.ph';
	    require 'asm/mpspec.ph';
	    if(defined(&CONFIG_X86_IO_APIC)) {
		require 'asm/io_apic.ph';
	    }
	    require 'asm/apic.ph';
	    require 'asm/thread_info.ph';
	}
    }
    if(defined(&CONFIG_SMP)) {
	unless(defined(&ASSEMBLY)) {
	    require 'asm/pda.ph';
	    eval 'sub SMP_TRAMPOLINE_BASE () {0x6000;}' unless defined(&SMP_TRAMPOLINE_BASE);
	    eval 'sub __smp_processor_id () {
	        eval q( &read_pda( &cpunumber));
	    }' unless defined(&__smp_processor_id);
	    eval 'sub hard_smp_processor_id {
	        my($void) = @_;
    		eval q({  &GET_APIC_ID(*( &APIC_BASE+ &APIC_ID)); });
	    }' unless defined(&hard_smp_processor_id);
	}
	eval 'sub NO_PROC_ID () {0xff;}' unless defined(&NO_PROC_ID);
    }
    unless(defined(&ASSEMBLY)) {
	eval 'sub cpu_mask_to_apicid {
	    my($cpumask) = @_;
    	    eval q({  &cpus_addr($cpumask)[0]; });
	}' unless defined(&cpu_mask_to_apicid);
	eval 'sub cpu_present_to_apicid {
	    my($mps_cpu) = @_;
    	    eval q({  &if ($mps_cpu <  &NR_CPUS)  $bios_cpu_apicid[$mps_cpu];  &else  &BAD_APICID; });
	}' unless defined(&cpu_present_to_apicid);
    }
    unless(defined(&CONFIG_SMP)) {
	eval 'sub stack_smp_processor_id () {
	    eval q(0);
	}' unless defined(&stack_smp_processor_id);
	eval 'sub safe_smp_processor_id () {
	    eval q(0);
	}' unless defined(&safe_smp_processor_id);
	eval 'sub cpu_logical_map {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&cpu_logical_map);
    } else {
	require 'asm/thread_info.ph';
	eval 'sub stack_smp_processor_id () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&stack_smp_processor_id);
    }
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub logical_smp_processor_id {
	    my($void) = @_;
    	    eval q({  &GET_APIC_LOGICAL_ID(*( &APIC_BASE+ &APIC_LDR)); });
	}' unless defined(&logical_smp_processor_id);
    }
}
1;
