require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__X86_64_UACCESS_H)) {
    eval 'sub __X86_64_UACCESS_H () {1;}' unless defined(&__X86_64_UACCESS_H);
    require 'linux/config.ph';
    require 'linux/compiler.ph';
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    require 'linux/prefetch.ph';
    require 'asm/page.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub MAKE_MM_SEG {
        my($s) = @_;
	    eval q((( &mm_segment_t) { ($s) }));
    }' unless defined(&MAKE_MM_SEG);
    eval 'sub KERNEL_DS () { &MAKE_MM_SEG(0xffffffffffffffff);}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () { &MAKE_MM_SEG( &PAGE_OFFSET);}' unless defined(&USER_DS);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( &current_thread_info()-> &addr_limit));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( &current_thread_info()-> &addr_limit = ($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __addr_ok {
        my($addr) = @_;
	    eval q((!(($addr) & ( &current_thread_info()-> ($addr_limit->{seg})))));
    }' unless defined(&__addr_ok);
    eval 'sub __range_not_ok {
        my($addr,$size) = @_;
	    eval q(({ \'unsigned long flag\', &sum;  &__chk_user_ptr;  &asm(\\"# range_ok\\\\n\\\\r\\" \\"addq %3,%1 ; sbbq %0,%0 ; cmpq %1,%4 ; sbbq $0,%0\\" :\\"=&r\\" , \\"=r\\" :\\"1\\" ,\\"g\\" (($size)),\\"g\\" ( &current_thread_info()-> ($addr_limit->{seg})));  &flag; }));
    }' unless defined(&__range_not_ok);
    eval 'sub access_ok {
        my($type, $addr, $size) = @_;
	    eval q(( &__range_not_ok($addr,$size) == 0));
    }' unless defined(&access_ok);
    eval 'sub ARCH_HAS_SEARCH_EXTABLE () {1;}' unless defined(&ARCH_HAS_SEARCH_EXTABLE);
    eval 'sub __get_user_x {
        my($size,$ret,$x,$ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_x);
    eval 'sub get_user {
        my($x,$ptr) = @_;
	    eval q(({ \'unsigned long __val_gu\'; \'int\'  &__ret_gu;  &__chk_user_ptr($ptr);  &switch($sizeof{($ptr)}) {  &case 1:  &__get_user_x(1, &__ret_gu, &__val_gu,$ptr);  &break;  &case 2:  &__get_user_x(2, &__ret_gu, &__val_gu,$ptr);  &break;  &case 4:  &__get_user_x(4, &__ret_gu, &__val_gu,$ptr);  &break;  &case 8:  &__get_user_x(8, &__ret_gu, &__val_gu,$ptr);  &break;  &default:  &__get_user_bad();  &break; } ($x) = ( &__typeof__(*($ptr))) &__val_gu;  &__ret_gu; }));
    }' unless defined(&get_user);
    eval 'sub __put_user_x {
        my($size,$ret,$x,$ptr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_x);
    eval 'sub put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_check(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&put_user);
    eval 'sub __get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub __put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(( &__typeof__(*($ptr)))($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user_unaligned () { &__get_user;}' unless defined(&__get_user_unaligned);
    eval 'sub __put_user_unaligned () { &__put_user;}' unless defined(&__put_user_unaligned);
    eval 'sub __put_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'int\'  &__pu_err;  &__put_user_size(($x),($ptr),($size), &__pu_err);  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'int\'  &__pu_err;  &__typeof__(*($ptr))  &__user * &__pu_addr = ($ptr);  &switch ($size) {  &case 1:  &__put_user_x(1, &__pu_err,$x, &__pu_addr);  &break;  &case 2:  &__put_user_x(2, &__pu_err,$x, &__pu_addr);  &break;  &case 4:  &__put_user_x(4, &__pu_err,$x, &__pu_addr);  &break;  &case 8:  &__put_user_x(8, &__pu_err,$x, &__pu_addr);  &break;  &default:  &__put_user_bad(); }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_size {
        my($x,$ptr,$size,$retval) = @_;
	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__put_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"iq\\",- &EFAULT);  &break;  &case 2:  &__put_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"ir\\",- &EFAULT);  &break;  &case 4:  &__put_user_asm($x,$ptr,$retval,\\"l\\",\\"k\\",\\"ir\\",- &EFAULT);  &break;  &case 8:  &__put_user_asm($x,$ptr,$retval,\\"q\\",\\"\\",\\"ir\\",- &EFAULT);  &break;  &default:  &__put_user_bad(); } }  &while (0));
    }' unless defined(&__put_user_size);
    eval 'sub __m {
        my($x) = @_;
	    eval q((*(\'struct __large_struct\'  &__user *)($x)));
    }' unless defined(&__m);
    eval 'sub __put_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errno) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_asm);
    eval 'sub __get_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'int\'  &__gu_err; \'unsigned long __gu_val\';  &__get_user_size( &__gu_val,($ptr),($size), &__gu_err); ($x) = ( &__typeof__(*($ptr))) &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_size {
        my($x,$ptr,$size,$retval) = @_;
	    eval q( &do { $retval = 0;  &__chk_user_ptr($ptr);  &switch ($size) {  &case 1:  &__get_user_asm($x,$ptr,$retval,\\"b\\",\\"b\\",\\"=q\\",- &EFAULT);  &break;  &case 2:  &__get_user_asm($x,$ptr,$retval,\\"w\\",\\"w\\",\\"=r\\",- &EFAULT);  &break;  &case 4:  &__get_user_asm($x,$ptr,$retval,\\"l\\",\\"k\\",\\"=r\\",- &EFAULT);  &break;  &case 8:  &__get_user_asm($x,$ptr,$retval,\\"q\\",\\"\\",\\"=r\\",- &EFAULT);  &break;  &default: ($x) =  &__get_user_bad(); } }  &while (0));
    }' unless defined(&__get_user_size);
    eval 'sub __get_user_asm {
        my($x, $addr, $err, $itype, $rtype, $ltype, $errno) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_asm);
    eval 'sub __copy_from_user {
        my($dst,$src,$size) = @_;
	    eval q({ \'int\'  &ret = 0;  &if (! &__builtin_constant_p($size))  &copy_user_generic($dst,( &__force  &void *)$src,$size);  &switch ($size) {  &case 1: &__get_user_asm(*( &u8*)$dst,( &u8  &__user *)$src, &ret,\\"b\\",\\"b\\",\\"=q\\",1);  &ret;  &case 2: &__get_user_asm(*( &u16*)$dst,( &u16  &__user *)$src, &ret,\\"w\\",\\"w\\",\\"=r\\",2);  &ret;  &case 4: &__get_user_asm(*( &u32*)$dst,( &u32  &__user *)$src, &ret,\\"l\\",\\"k\\",\\"=r\\",4);  &ret;  &case 8: &__get_user_asm(*( &u64*)$dst,( &u64  &__user *)$src, &ret,\\"q\\",\\"\\",\\"=r\\",8);  &ret;  &case 10:  &__get_user_asm(*( &u64*)$dst,( &u64  &__user *)$src, &ret,\\"q\\",\\"\\",\\"=r\\",16);  &if ( &unlikely( &ret))  &ret;  &__get_user_asm(*( &u16*)(8+$dst),( &u16  &__user *)(8+(\'char\'  &__user *)$src), &ret,\\"w\\",\\"w\\",\\"=r\\",2);  &ret;  &case 16:  &__get_user_asm(*( &u64*)$dst,( &u64  &__user *)$src, &ret,\\"q\\",\\"\\",\\"=r\\",16);  &if ( &unlikely( &ret))  &ret;  &__get_user_asm(*( &u64*)(8+$dst),( &u64  &__user *)(8+(\'char\'  &__user *)$src), &ret,\\"q\\",\\"\\",\\"=r\\",8);  &ret;  &default:  &copy_user_generic($dst,( &__force  &void *)$src,$size); } } );
    }' unless defined(&__copy_from_user);
    eval 'sub __copy_to_user {
        my($dst,$src,$size) = @_;
	    eval q({ \'int\'  &ret = 0;  &if (! &__builtin_constant_p($size))  &copy_user_generic(( &__force  &void *)$dst,$src,$size);  &switch ($size) {  &case 1: &__put_user_asm(*( &u8*)$src,( &u8  &__user *)$dst, &ret,\\"b\\",\\"b\\",\\"iq\\",1);  &ret;  &case 2: &__put_user_asm(*( &u16*)$src,( &u16  &__user *)$dst, &ret,\\"w\\",\\"w\\",\\"ir\\",2);  &ret;  &case 4: &__put_user_asm(*( &u32*)$src,( &u32  &__user *)$dst, &ret,\\"l\\",\\"k\\",\\"ir\\",4);  &ret;  &case 8: &__put_user_asm(*( &u64*)$src,( &u64  &__user *)$dst, &ret,\\"q\\",\\"\\",\\"ir\\",8);  &ret;  &case 10:  &__put_user_asm(*( &u64*)$src,( &u64  &__user *)$dst, &ret,\\"q\\",\\"\\",\\"ir\\",10);  &if ( &unlikely( &ret))  &ret;  &asm(\\"\\":::\\"memory\\");  &__put_user_asm(4[( &u16*)$src],4+( &u16  &__user *)$dst, &ret,\\"w\\",\\"w\\",\\"ir\\",2);  &ret;  &case 16:  &__put_user_asm(*( &u64*)$src,( &u64  &__user *)$dst, &ret,\\"q\\",\\"\\",\\"ir\\",16);  &if ( &unlikely( &ret))  &ret;  &asm(\\"\\":::\\"memory\\");  &__put_user_asm(1[( &u64*)$src],1+( &u64  &__user *)$dst, &ret,\\"q\\",\\"\\",\\"ir\\",8);  &ret;  &default:  &copy_user_generic(( &__force  &void *)$dst,$src,$size); } } );
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_in_user {
        my($dst,$src,$size) = @_;
	    eval q({ \'int\'  &ret = 0;  &if (! &__builtin_constant_p($size))  &copy_user_generic(( &__force  &void *)$dst,( &__force  &void *)$src,$size);  &switch ($size) {  &case 1: {  &u8  &tmp;  &__get_user_asm( &tmp,( &u8  &__user *)$src, &ret,\\"b\\",\\"b\\",\\"=q\\",1);  &if ( &likely(! &ret))  &__put_user_asm( &tmp,( &u8  &__user *)$dst, &ret,\\"b\\",\\"b\\",\\"iq\\",1);  &ret; }  &case 2: {  &u16  &tmp;  &__get_user_asm( &tmp,( &u16  &__user *)$src, &ret,\\"w\\",\\"w\\",\\"=r\\",2);  &if ( &likely(! &ret))  &__put_user_asm( &tmp,( &u16  &__user *)$dst, &ret,\\"w\\",\\"w\\",\\"ir\\",2);  &ret; }  &case 4: {  &u32  &tmp;  &__get_user_asm( &tmp,( &u32  &__user *)$src, &ret,\\"l\\",\\"k\\",\\"=r\\",4);  &if ( &likely(! &ret))  &__put_user_asm( &tmp,( &u32  &__user *)$dst, &ret,\\"l\\",\\"k\\",\\"ir\\",4);  &ret; }  &case 8: {  &u64  &tmp;  &__get_user_asm( &tmp,( &u64  &__user *)$src, &ret,\\"q\\",\\"\\",\\"=r\\",8);  &if ( &likely(! &ret))  &__put_user_asm( &tmp,( &u64  &__user *)$dst, &ret,\\"q\\",\\"\\",\\"ir\\",8);  &ret; }  &default:  &copy_user_generic(( &__force  &void *)$dst,( &__force  &void *)$src,$size); } } );
    }' unless defined(&__copy_in_user);
    eval 'sub __copy_to_user_inatomic () { &__copy_to_user;}' unless defined(&__copy_to_user_inatomic);
    eval 'sub __copy_from_user_inatomic () { &__copy_from_user;}' unless defined(&__copy_from_user_inatomic);
}
1;
