require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUPDATE_H)) {
    eval 'sub __LINUX_RCUPDATE_H () {1;}' unless defined(&__LINUX_RCUPDATE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/cache.ph';
	require 'linux/spinlock.ph';
	require 'linux/threads.ph';
	require 'linux/percpu.ph';
	require 'linux/cpumask.ph';
	require 'linux/seqlock.ph';
	eval 'sub RCU_HEAD_INIT {
	    my($head) = @_;
    	    eval q({ . &next =  &NULL, . &func =  &NULL });
	}' unless defined(&RCU_HEAD_INIT);
	eval 'sub RCU_HEAD {
	    my($head) = @_;
    	    eval q(\'struct rcu_head\' $head =  &RCU_HEAD_INIT($head));
	}' unless defined(&RCU_HEAD);
	eval 'sub INIT_RCU_HEAD {
	    my($ptr) = @_;
    	    eval q( &do { ($ptr)-> &next =  &NULL; ($ptr)-> &func =  &NULL; }  &while (0));
	}' unless defined(&INIT_RCU_HEAD);
	eval 'sub rcu_bh_qsctr_inc {
	    my($cpu) = @_;
    	    eval q({ \'struct rcu_data\' * &rdp =  &per_cpu( &rcu_bh_data, $cpu);  ($rdp->{passed_quiesc}) = 1; });
	}' unless defined(&rcu_bh_qsctr_inc);
	eval 'sub __rcu_pending {
	    my($rcp,$rdp) = @_;
    	    eval q({  &if ( ($rdp->{curlist})  && ! &rcu_batch_before( ($rcp->{completed}),  ($rdp->{batch}))) 1;  &if (! ($rdp->{curlist})  &&  ($rdp->{nxtlist})) 1;  &if ( ($rdp->{donelist})) 1;  &if ( ($rdp->{quiescbatch}) !=  ($rcp->{cur}) ||  ($rdp->{qs_pending})) 1; 0; });
	}' unless defined(&__rcu_pending);
	eval 'sub rcu_pending {
	    my($cpu) = @_;
    	    eval q({  &__rcu_pending( &rcu_ctrlblk,  &per_cpu( &rcu_data, $cpu)) ||  &__rcu_pending( &rcu_bh_ctrlblk,  &per_cpu( &rcu_bh_data, $cpu)); });
	}' unless defined(&rcu_pending);
	eval 'sub rcu_read_lock () {
	    eval q( &preempt_disable());
	}' unless defined(&rcu_read_lock);
	eval 'sub rcu_read_unlock () {
	    eval q( &preempt_enable());
	}' unless defined(&rcu_read_unlock);
	eval 'sub rcu_read_lock_bh () {
	    eval q( &local_bh_disable());
	}' unless defined(&rcu_read_lock_bh);
	eval 'sub rcu_read_unlock_bh () {
	    eval q( &local_bh_enable());
	}' unless defined(&rcu_read_unlock_bh);
	eval 'sub rcu_dereference {
	    my($p) = @_;
    	    eval q(({  &typeof($p)  &_________p1 = $p;  &smp_read_barrier_depends(); ( &_________p1); }));
	}' unless defined(&rcu_dereference);
	eval 'sub rcu_assign_pointer {
	    my($p, $v) = @_;
    	    eval q(({  &smp_wmb(); ($p) = ($v); }));
	}' unless defined(&rcu_assign_pointer);
	eval 'sub synchronize_sched () {
	    eval q( &synchronize_rcu());
	}' unless defined(&synchronize_sched);
    }
}
1;
